# Vixeny

<p align="center">
  <img src="misc/logo.png" alt="Vixeny Logo" style="max-width: 100%;">
  <br>
  <b style="font-size:1.2em; font-style:italic; color:darkcyan;">Unleash the functional beast~</b>
</p>

## Introduction

Welcome to Vixeny, a web framework that combines the strengths of functional programming with broad support for various coding paradigms. Whether you are an experienced functional programmer, new to the concept, or prefer other approaches altogether, Vixeny has something to offer you.

### Embracing Different Styles

Vixeny celebrates flexibility, expressiveness, and the joy of coding. Our philosophy supports various programming styles, making it unique and accessible for different developers:

- **Functional, but Not Exclusive:** Vixeny uses functional programming as a tool, not a constraint. It provides support for multiple paradigms, fostering different paths to success.
- **Modular and Predictable:** With functional principles at its core, Vixeny ensures easy testing, predictable and immutable structures, fostering a robust and reliable development environment.
- **Opt-in Side Effects:** Side effects are an option in Vixeny, giving you control to create them when needed, ensuring intentionality.
- **High-Performance, Elegance, and More:** Vixeny's commitment to performance, safety, readability, and community aligns with various programming principles, not just functional ones.
- **Testing with Pure Functionality:** The pure nature of Vixeny's operations and data structures facilitates rigorous testing. Mocking, especially of async functions, allows developers to isolate their code from external dependencies. This ensures tests are deterministic, reproducible, and unaffected by external factors, making Vixeny's development environment even more reliable and efficient.

Dive into our Getting Started guide and discover how Vixeny meets you where you are, helping you build extraordinary web applications.

## Docs

**Important Notice:** Our documentation is currently under construction. In order to provide a better experience, we have moved the documents to a separate location while we work on the website. Stay tuned for updates, and in the meantime, explore Vixeny through the website below!

[Visit our website](https://vixeny.dev/)

## Benchmarks

### Bun
[By SaltyAom](https://github.com/SaltyAom/bun-http-framework-benchmark)

### Deno
[By Denosaurs](https://github.com/denosaurs/bench)

## Q&A

- **Why doesn't Vixeny support Node.js?**
  Node.js is not supported due to its incompatibility with the Response and Request methods used by Vixeny.

## License

[CC BY-ND 4.0](https://creativecommons.org/licenses/by-nd/4.0/legalcode.txt)
